library(colourvision)
library(plotrix)

setwd("~/Dropbox/Students Postdocs/Carl Santiago/Carl MS/CARLS DATA REMEASURED USE THIS ONE/R code Colour Vision Package/Expt2")

# Use colourvision package to model target colours
C<-read.csv("vis_dat_halfYC.csv")
# or to specify lambda max: C<-photor(lambda.max=c(350,450,550))
I<-read.csv("flat_illuminant.csv")
noise=c(0.07, 0.05, 0.05)

Rb<- read.csv("Rb_White_ipad_EXP2.csv")
R2<-read.csv("R2_AvDistractor_EXP2.csv")


# plot distractor
R1<-read.csv("R1_Distractor_colours_EXP2.csv")
plotcolours <- read.csv("scatterdot_RGB_EXP2_distractor.csv")

# plot target colours
R1<-read.csv("R1_Target_colours_EXP2.csv")
plotcolours <- read.csv("scatterdot_RGB_EXP2_target.csv")

model<-RNLmodel(photo=3, model="log",
                R1=R1, 
                R2=R2, 
                Rb=Rb, 
                I=I, 
                C=C,
                nm=seq(400,700,5),
                noise=TRUE, 
                e = c(noise))

plotrgb <- plotcolours[c(1:3)]

#Plot data with specific tick values
#v1 <- c(-8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8)
#v2 <- c(-8, -7, -6, -5, -4, -3, -2, -1, 0, 1,2,3,4,5,6, 7, 8)

RNLplot(model, photo=3, item="R1",
        vectors=TRUE, vnames=FALSE, vsize=c(-12,12), 
        col = rgb(plotrgb),
        pch = 19, cex = 2,
        xlab="X1", ylab="X2", asp=F, xlim=c(-12,12), ylim=c(-18,18))


write.csv(cbind(model$Qr1_R1, model$Qr2_R1, model$Qr3_R1), file = "QC_targets_Expt2.csv")
write.csv(model$deltaS, file = "DS_targets_green.csv")

# TO PLOT IN PAVO
library(pavo)

I<-read.csv("flat_illuminant.csv")
C<-read.csv("vis_dat_halfYC_1.csv")
R1dis<-read.csv("R1_Distractor_colours_EXP2.csv")
#R1tar<-read.csv("R1_Target_colours_EXP1b_photons_norm.csv")
Rb <- read.csv("RB_White_ipad_EXP1b_photons_norm.csv")
R2<-read.csv("R2_AvDistractor_EXP1b_photons_norm.csv")
#plotcoloursdis <- read.csv("scatterdot_RGB_EXP1b_distractor.csv")
plotcolourstarget <- read.csv("scatterdot_RGB_EXP1b_target.csv")
#plotrgb <- plotcoloursdis[c(1:3)]
plotrgb <- plotcolourstarget[c(1:3)]

#pavo requires all the spectral data to be in 1nm increments, so use as.rspec 
#to change our data from increasing in 5nm increments to 1nm increments.

C_2<-as.rspec(C)
R1_2<-as.rspec(R1tar)
Rb_2<-as.rspec(Rb)
Rb_3<-as.data.frame(Rb[,2])
I_2<-as.rspec(I)
I_4<-as.data.frame(I_2[,2])

#pavo will warn you about some negative values. You can fix this using 
#R1_4<-procspec(R1_2, opt = "smooth")
#but I haven't been worrying too much about this (i think some people (-ie. Justin),
#don't like smoothing functions) 

#calculate quantum catches
vis<- vismodel(R1_2, visual = C_2, achromatic = "l", illum = I_4, vonkries =TRUE, bkg=Rb_3)

#get x y coordinates for Maxwell
tri<- colspace(vis, space = "tri")

#plot in Maxwell
plot(tri, col = rgb(plotrgb))

#To use pavo to calculate deltaS using RNL model
distance_noise<-coldist(vis, achromatic=FALSE,  n=c(1,2,2), weber=0.05)

#convert from deltaS to coordinates for RNL space
noise_to_xy<-jnd2xyz(distance_noise, center = FALSE, rotcenter ="achro", ref1 = "s", ref2 = "l", rotate = TRUE)

#plot in RNL space using pavo
jndplot(noise_to_xy,  arrow = "relative", col = rgb(plotrgb), arrow.p = 2, cex = 2, xlim=c(-18,18), ylim=c(-18,18))   



